#############################################################################
##
#W FDagain.gi 			 HAPcryst package		 Marc Roeder
##
##  

##
#H @(#)$Id: FDagain.gi, v 0.1.1 2007/08/23 18:08:51 gap Exp $
##
#Y	 Copyright (C) 2006 Marc Roeder 
#Y 
#Y This program is free software; you can redistribute it and/or 
#Y modify it under the terms of the GNU General Public License 
#Y as published by the Free Software Foundation; either version 2 
#Y of the License, or (at your option) any later version. 
#Y 
#Y This program is distributed in the hope that it will be useful, 
#Y but WITHOUT ANY WARRANTY; without even the implied warranty of 
#Y MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
#Y GNU General Public License for more details. 
#Y 
#Y You should have received a copy of the GNU General Public License 
#Y along with this program; if not, write to the Free Software 
#Y Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
##
Revision.("/home/roeder/gap/HAPcryst/HAPcryst/lib/FDagain_gi"):=
	"@(#)$Id: FDagain.gi, v 0.1.1 2007/08/23   18:08:51  gap Exp $";
                                        
initialInequalities:=function(center,orbitpart,gram)
    local   dim,  directions,  points,  ineqs;
    
    dim:=Size(center);
    directions:=Union(IdentityMat(dim),-IdentityMat(dim));
    points:=[];
    points:=Set(OrbitPartAtPointFromOrbitPartAtOrigin(center,orbitpart));
    UniteSet(points,center+directions);
#    UniteSet(points,Union(List(directions,d->d+points)));
    if gram<>IdentityMat(dim)
       then
        ineqs:=Set(points,
                   i->BisectorInequalityFromPointPair(center,i,gram));
    else
        ineqs:=Set(points,
                   i->BisectorInequalityFromPointPair(center,i));
    fi;
    RemoveSet(ineqs,fail);
    return ineqs;
end;


TranslationsToOneCubeAroundCenter:=function(point,center)
    local   returnlist, abs, trans,  difference,  entry;
    
    returnlist:=[];
    trans:=List(center-point,Int);
    difference:=center-(trans+point);
    for entry in [1..Size(difference)]
      do
        abs:=AbsoluteValue(difference[entry]);
        if abs=1/2
           then
            difference[entry]:=[0,SignRat(difference[entry])];
        elif abs>1/2
          then
            difference[entry]:=[SignRat(difference[entry])];
        else
            difference[entry]:=[0];
        fi;
    od;
    return trans+Cartesian(difference);
end;


satisfiesAllInequalities:=function(point,ineqs)
    return ForAll(ineqs,i->WhichSideOfHyperplane(point,i) in [0,1]);
end;



newInequalitiesEuclidian:=function(vertex,center,ineqs,vertices,pointGrpReps)
    local   dim,  centeraff,  affinevertex,  returnlist,  g,  
            affimage,  image,  trans,  t,  gl,  gli,  gt;
    
    dim:=Size(vertex);
    centeraff:=Concatenation(center,[1]);
    affinevertex:=Concatenation(vertex,[1]);
    returnlist:=[];
    for g in pointGrpReps
      do
        affimage:=affinevertex*g;
        image:=affimage{[1..dim]};
        trans:=TranslationsToOneCubeAroundCenter(image,center);
        for t in trans 
          do
            if not image+t in vertices 
               then
                if satisfiesAllInequalities(image+t,ineqs)
                   then
                    gl:=LinearPartOfAffineMatOnRight(g);
                    gli:=Inverse(gl);
                    gt:=g[dim+1]{[1..dim]};
                    Add(returnlist,center*gl+gt+t);
                    Add(returnlist,(center-gt-t)*gli);
                fi;
            fi;
        od;
    od;
    returnlist:=Set(returnlist);
    RemoveSet(returnlist,center);
    returnlist:=Set(returnlist,i->BisectorInequalityFromPointPair(center,i));
    return Filtered(returnlist,i->ForAny(vertices,v->WhichSideOfHyperplane(v,i)=-1));
end;


newInequalities:=function(vertex,center,ineqs,vertices,pointGrpReps,gram)
    local   dim,  centeraff,  affinevertex,  returnlist,  g,  
            affimage,  image,  trans,  t,  gl,  gli,  gt;
    
    dim:=Size(vertex);
    centeraff:=Concatenation(center,[1]);
    affinevertex:=Concatenation(vertex,[1]);
    returnlist:=[];
    for g in pointGrpReps
      do
        affimage:=affinevertex*g;
        image:=affimage{[1..dim]};
        trans:=TranslationsToOneCubeAroundCenter(image,center);
        for t in trans 
          do
            if not image+t in vertices 
               then
                if satisfiesAllInequalities(image+t,ineqs)
                   then
                    gl:=LinearPartOfAffineMatOnRight(g);
                    gli:=Inverse(gl);
                    gt:=g[dim+1]{[1..dim]};
                    Add(returnlist,center*gl+gt+t);
                    Add(returnlist,(center-gt-t)*gli);
                fi;
            fi;
        od;
    od;
    returnlist:=Set(returnlist);
    RemoveSet(returnlist,center);
    returnlist:=Set(returnlist,i->BisectorInequalityFromPointPair(center,i,gram));
    return Filtered(returnlist,i->ForAny(vertices,v->WhichSideOfHyperplane(v,i)=-1));
end;
    
    
PolytopeFromCenterAndpointGrpReps:=function(center,pointGrpReps,gram)
    local   dim,  orbitpart,  partialFD,  newinequalities,  
            oldinequalities,  donevertices,  rsquare,  allvertices,  
            vertices,  vertexiterator,  inequalities,  v,  new;

    dim:=Size(center);
    isEuclidian:=(gram=IdentityMat(dim));
    orbitpart:=OrbitStabilizerInUnitCubeOnRight(center,pointGrpReps).orbit;;
# First, generate the initial polyhedron:
    partialFD:=CreatePolymakeObject("partialFD",POLYMAKE_DATA_DIR);
    newinequalities:=initialInequalities(center,orbitpart,gram);;
    AppendInequalitiesToPolymakeObject(partialFD,newinequalities);
    Polymake(partialFD,"VERTICES FACETS");
    newinequalities:=[];
    oldinequalities:=[];
    donevertices:=[];
    rsquare:=1;
    
    repeat
        allvertices:=AsSet(Polymake(partialFD,"VERTICES"));
        vertices:=Filtered(Polymake(partialFD,"VERTICES"),v->not v in donevertices);
        if vertices=[] then Print("out of vertices"); return partialFD;fi;
        vertexiterator:=Iterator(vertices);
        inequalities:=Set(Polymake(partialFD,"FACETS"));
        Print("v: ",Size(vertices)," f:",
              Size(inequalities),"  \c");
        newinequalities:=[];
        if isEuclidian
           then
            repeat
                v:=NextIterator(vertexiterator);
                AddSet(donevertices,v);
                if satisfiesAllInequalities(v,newinequalities)
                   then
                    new:= newInequalities(v,center,inequalities,
                                  allvertices,pointGrpReps);
                    UniteSet(newinequalities,new);
                    UniteSet(inequalities,new);
                fi;
            until IsDoneIterator(vertexiterator) or Size(newinequalities)>200;            
        else
            repeat
                v:=NextIterator(vertexiterator);
                AddSet(donevertices,v);
                if satisfiesAllInequalities(v,newinequalities)
                   then
                    new:= newInequalities(v,center,inequalities,
                                  allvertices,pointGrpReps,gram);
                    UniteSet(newinequalities,new);
                    UniteSet(inequalities,new);
                fi;
            until IsDoneIterator(vertexiterator) or Size(newinequalities)>200;
        fi;

        Print("ne: ",Size(newinequalities),"\n");
        ClearPolymakeObject(partialFD);
        AppendInequalitiesToPolymakeObject(partialFD,inequalities);;
        Polymake(partialFD,"VERTICES FACETS");
    until newinequalities=[];
    Print("out of inequalities");
    return partialFD;
end;

