#############################################################################
##
#W chaincomplex.gi 			 HAPcryst package		 Marc Roeder
##
##  

##
#H @(#)$Id: chaincomplex.gi, v 0.1.1 2007/08/23 18:08:51 gap Exp $
##
#Y	 Copyright (C) 2006 Marc Roeder 
#Y 
#Y This program is free software; you can redistribute it and/or 
#Y modify it under the terms of the GNU General Public License 
#Y as published by the Free Software Foundation; either version 2 
#Y of the License, or (at your option) any later version. 
#Y 
#Y This program is distributed in the hope that it will be useful, 
#Y but WITHOUT ANY WARRANTY; without even the implied warranty of 
#Y MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
#Y GNU General Public License for more details. 
#Y 
#Y You should have received a copy of the GNU General Public License 
#Y along with this program; if not, write to the Free Software 
#Y Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
##
Revision.("/home/roeder/gap/HAPcryst/HAPcryst/lib/chaincomplex_gi"):=
	"@(#)$Id: chaincomplex.gi, v 0.1.1 2007/08/23   18:08:51  gap Exp $";
############
## This does not work as the output of the polymake package has changed...
###

InstallMethod(ChainComplexFromPolygon,"for polygons",
        [IsPolymakeObject],
        function(poly)
    local   hasseDiagram,  maxdim,  dimension,   
            boundary,  hasse,  properties, knownboundaries;

    
    hasseDiagram:=Polymake(poly,"HASSE_DIAGRAM");
    maxdim:=Size(hasseDiagram.faceindices)-1;
    knownboundaries:=[];


    dimension:=function(k)
        if k<0 or k>maxdim
           then
            return 0;
        else
            return Size(hasseDiagram.faceindices[k+1]);
        fi;
    end;
    
    
    ##############################
    # can I do this without using or returning a global variable?
    #
    
    boundary:=function(k,j)
        local   boundarycompressed,  offset,  kminus1offset,  compressed,  
                returnvec;

        boundarycompressed:=function(face)
            local   bound,  edgestodo,  firstedge,  edgesdone,  
                    edgesforthisrun,  nextedges,  pointsdone,  edge,  
                    points,  boundary,  point,  otheredge,  
                    otheredgebound;

            if face in hasseDiagram.faceindices[2] #i.e. face is a 1-face
               then
                bound:=[[hasseDiagram.hasse[face][3][1],1],
                        [hasseDiagram.hasse[face][3][2],-1]];
                #knownboundaries[face]:=Set(bound);
                return bound;
            elif IsBound(knownboundaries[face])
              then
                return knownboundaries[face];
            else
                edgestodo:=Set(hasseDiagram.hasse[face][3]);
                firstedge:=Remove(edgestodo);
                edgesdone:=[[firstedge,1]];
                edgesforthisrun:=[firstedge];
                nextedges:=[];
                pointsdone:=[];
                repeat
                    for edge in edgesforthisrun
                      do 
                        points:=Difference(hasseDiagram.hasse[edge][3],pointsdone);
                        boundary:=boundarycompressed(edge);
                        for point in points
                          do
                            otheredge:=First(edgestodo,e-> 
                                             e in hasseDiagram.hasse[point][2]);
                            if otheredge<> fail
                               then
                                otheredgebound:=boundarycompressed(otheredge); 
                                if First(boundary,i->i[1]=point)[2]=
                                   First(otheredgebound,i->i[1]=point)[2]
                                   then
                                    Add(edgesdone,[otheredge,-1]);
                                else
                                    Add(edgesdone,[otheredge,1]);
                                fi;
                                RemoveSet(edgestodo,otheredge);
                                Add(nextedges,otheredge);
                            fi;
                            AddSet(pointsdone,point);
                        od;
                    od;
                    edgesforthisrun:=StructuralCopy(nextedges);
                    nextedges:=[];
                until edgesforthisrun=[];
                knownboundaries[face]:=Set(edgesdone);
                return edgesdone;
            fi;
        end;

        if not j <= Size(hasseDiagram.faceindices[k+1])
           then
            Error("face index out of range");
        fi;
        
        if k<=0 or k>=Size(hasseDiagram.faceindices)
           then
            return [];
        else
            knownboundaries:=[];
            offset:=hasseDiagram.faceindices[k+1][1]-1;
            kminus1offset:=hasseDiagram.faceindices[k][1]-1;
            compressed:=List(boundarycompressed(offset+j),
                             i->[i[1]-kminus1offset,i[2]]);

            returnvec:=List([1..Size(hasseDiagram.faceindices[k])],i->0);
            returnvec{List(compressed,i->i[1])}:=List(compressed,i->i[2]);
            return returnvec;
        fi;
    end;
    
    return Objectify(HapChainComplex,
                   rec(
                       dimension:=dimension,
                       boundary:=boundary,
                       knownboundaries:=knownboundaries,
                       hasse:=hasseDiagram,
                       properties:=
                       [["length",maxdim],
                        ["type","chainComplex"],
                        ["characteristic",0]
                        ]
                       ));
end);

