#############################################################################
##
#W geometricjunk.gd 			 HAPcryst package		 Marc Roeder
##
##  

##
#H @(#)$Id: geometricjunk.gd, v 0.1.1 2007/08/23 18:08:51 gap Exp $
##
#Y	 Copyright (C) 2006 Marc Roeder 
#Y 
#Y This program is free software; you can redistribute it and/or 
#Y modify it under the terms of the GNU General Public License 
#Y as published by the Free Software Foundation; either version 2 
#Y of the License, or (at your option) any later version. 
#Y 
#Y This program is distributed in the hope that it will be useful, 
#Y but WITHOUT ANY WARRANTY; without even the implied warranty of 
#Y MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
#Y GNU General Public License for more details. 
#Y 
#Y You should have received a copy of the GNU General Public License 
#Y along with this program; if not, write to the Free Software 
#Y Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
##
Revision.("/home/roeder/gap/HAPcryst/HAPcryst/lib/geometricjunk_gd"):=
	"@(#)$Id: geometricjunk.gd, v 0.1.1 2007/08/23   18:08:51  gap Exp $";
##############################
#
# Two do-it-all-at-once functions for fundamental domains. Just 
# enter a point and the output from "LatticeTransAndPointGroupRepsOnRight"
# and off you go.
# Or enter a point and the part of the orbit which lies inside $[0,1]^n$
#
# But make sure it is a general (i.e. trivial stabilizer) point!
#

DeclareOperation("FundamentalDomainFromRegularPointOnRight",[IsVector,IsRecord]);
DeclareOperation("FundamentalDomainFromOrbit",[IsMatrix,IsVector,IsDenseList]);

##############################
#
# Two functions calculating the part of the orbit needed to find a
# fundamental domain via the Dirichlet-Voronoi method.
# The "NoTricks" version is very dull while the other one uses polymake.
#

DeclareOperation("PointlistForFundamentalDomainFromOrbit",[IsMatrix,IsVector,IsDenseList]);
DeclareOperation("PointlistForFundamentalDomainFromOrbitNoTricks",[IsVector,IsDenseList]);


##############################
#
# Generate a file for polymake which contains the Dirichlet domain
# as a set of inequalities.
#

DeclareOperation("DirichletDomain",[IsMatrix,IsVector,IsDenseList]);
DeclareOperation("DirichletDomain",[IsMatrix,IsVector,IsDenseList,IsString]);
DeclareOperation("DirichletDomain",[IsMatrix,IsVector,IsDenseList,IsDirectory]);
DeclareOperation("DirichletDomain",[IsMatrix,IsVector,IsDenseList,IsString,IsDirectory]);



DeclareOperation("ReflectedPointGramInverse",[IsVector,IsVector,IsMatrix]);
DeclareOperation("ReflectedPoint",[IsVector,IsVector,IsMatrix]);
DeclareOperation("ReflectedPoint",[IsVector,IsVector]);