#############################################################################
##
#W tmp.gi 			 HAPcryst package		 Marc Roeder
##
##  

##
#H @(#)$Id: tmp.gi, v 0.1.4 2007/10/17 14:22:33 gap Exp $
##
#Y	 Copyright (C) 2006 Marc Roeder 
#Y 
#Y This program is free software; you can redistribute it and/or 
#Y modify it under the terms of the GNU General Public License 
#Y as published by the Free Software Foundation; either version 2 
#Y of the License, or (at your option) any later version. 
#Y 
#Y This program is distributed in the hope that it will be useful, 
#Y but WITHOUT ANY WARRANTY; without even the implied warranty of 
#Y MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
#Y GNU General Public License for more details. 
#Y 
#Y You should have received a copy of the GNU General Public License 
#Y along with this program; if not, write to the Free Software 
#Y Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
##
Revision.("/home/roeder/gap/HAPcryst/HAPcryst/lib/tmp_gi"):=
	"@(#)$Id: tmp.gi, v 0.1.4 2007/10/17   14:22:33  gap Exp $";
# n: dimension of the cess we want the homotopy for
# R: the resolution (how do you say "this" ?)
# face: n-face to calculate the homotopy of

if face in maxspace[n]
   then
    return 0;
fi;
   
sphere:=R!.disc(n,face);
cellstocolor:=Difference(sphere,R.knownhomotopy(n));


#############################################################################
##
## undirectedBoundary calculates just the cells occuring in the boundary.
## signs and multiplicities are ignored.
##
undirectedBoundary:=function(dim,cell,boundary)
    return Set(boundary(dim,cell),i->[AbsInt(i[1]),i[2]]);
end;
    


#############################################################################
## 
## if cellsSoFar is a set of cells which is "bubble free".
##  any cell which may be added without destroying "bubble freeness"
##  is called "addable".
##  They are recognized by the fact that a part of their boundary must not be
##  a part of any boundary of the given "bubble free" set of cells.
##
addableCells:=function(cells,dim,boundary,cellsSoFar)
    local   undirectedBoundary,  boundariesSoFar;
    
    boundariesSoFar:=Union(Set(cellsSoFar,c->undirectedBoundary(dim,c)));
    return Filtered(cells,c->not IsSubset(boundariesSoFar,undirectedBoundary(dim,c)));
end;
    

#############################################################################
##
## Given a good space (list of lists of cells which belong to a maximal 
## contractable and dimension-wise "bubble free" subspace)
##
##  good and bad are lists of length (at most) $d$
##  each entry is a list of faces. The "good" are some faces belonging 
##  to a maximal contractible and "bubble free" subspace. the bad ones are 
##  those known not to belong to that subspace.
##  And "newcells" must be sorted into either of those. All lower-dimensional
##  faces contained in "newcells" must also be classified as "good" or "bad".
##
## "dimension" is the dimension of "newcells". And "good" and "bad" have to 
## be Sets.
##
colorTheseCells:=function(good, bad, newcells, dimension , boundary)
    
    ##################################################
    recursion:=function(goodcells,
                       cellstochoose,
                       cellschosen,
                       lowerdimcellstocover,
                       dimension,boundary)
               local thisgoodcells;
        thisgoodcells:=Union(goodcells,cellschosen);
        candidates:=addableCells(cellstochoose,dimension,boundary,thisgoodcells);
        if candidates<>[]
           then
            found:=fail;
            i:=1;
            while found=fail and i<Size(candidates)
              do
                found:=recursion(goodcells,
                        Difference(cellstochoose,candidates{[1..i]}),
                        Union(cellschosen,[candidates[i]]),
                        lowerdimcellstocover,
                        dimension,boundary);
            od;
        else
            coveredcells:=Union(Set(cellschosen,c->undirectedBoundary(dimension,c,boundary)));
            if IsSubset(lowerdimcellstocover,coveredcells)
               then
                found:=cellschosen;
            else
                found:=fail;
            fi;
        fi;
        return found;
    end;
    ##################################################
    
    knowncells:=Union(good[dimension],bad[dimension]);
    cells:=Filtered(newcells,c->not c in knowncells);
    if dimension>0
       then
        lowerdimcells:=Union(Set(cells,c->undirectedBoundary(dimension,c,boundary)));
        candidates:=addableCells(cells,dimension,boundary,good[dimension]);
        UniteSet(bad,Difference(cells,candidates));
        
    fi;
    if not Union(List(candidates,c->undirectedBoundary(dimension,c,boundary)))
       =Union(List(newgoodcells,c->undirectedBoundary(dimension,c,boundary)))
       then
        return fail;
    fi;
    UniteSet(good,newgoodcells);
end;